<?php

namespace Modules\Product\Requests\Canteen;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Product\Enums\ProductStockStatusEnum;
use Modules\Product\Enums\ReportEnum;
use Modules\Product\Enums\stockstockStatusEnum;
use Modules\User\Enums\UserRoleEnum;

class ReportRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::canteen_admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $statuses = ReportEnum::values();
        $rules =
            [
                'category_id'=>
                    [
                        'nullable',
                        Rule::exists('categories','id')->where('canteen_id',auth()->user()->canteen_id)->whereNull('deleted_at')
                    ],
                'product_id'=>
                    [
                        'nullable',
                        Rule::exists('products','id')->where('canteen_id',auth()->user()->canteen_id)->whereNull('deleted_at')
                    ],
                'start_date'=>
                    [
                        'required',
                        'date'
                    ],
                'end_date'=>
                    [
                        'required',
                        'date',
                        'after_or_equal:start_date'
                    ],
                'status'=>
                    [
                        'required',
                        'in:'.implode(',',$statuses)
                    ]
            ];

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'product_id'=>__('stocks.product_id'),
            'category_id'=>__('stocks.category_id'),
            'start_date'=>__('stocks.start_date'),
            'end_date'=>__('stocks.end_date'),
            'status'=>__('stocks.status')
        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
